Description

This appears to be a UI/UX regression in 1.10 in connection with the "Unsetting attributes" feature.

Steps to reproduce:

1. Create a new host

2. Select a host group without a compute profile attached

3. Select a compute resource to deploy onto (VMware in our case)

Results: A compute profile is selected and greyed out, indicating it has been inherited and applied. However when you navigate to

the "Virtual Machine" tab on the new host screen, it is apparent that the compute profile has not actually been applied.

Expected results: The compute profile field should not be selected and left active for the user to make a selection

Related issues:

Related to Foreman - Bug #9591: Override puppet configuration on host level d... Closed 03/01/2015

Related to Foreman - Bug #12618: Compute profile overrides compute attributes... Closed 11/26/2015

Related to Foreman - Bug #12659: Value cannot be overridden by unpressing the... Closed 12/02/2015

Related to Foreman - Bug #12793: organzation and location not saved for hostg... Closed 12/13/2015

Related to Foreman - Bug #12794: Environment in host isn't saved Closed 12/13/2015

Related to Foreman - Bug #13004: Compute Profiles not Inheriting from nested ... Closed 01/05/2016

Associated revisions

Revision 95d70642 - 11/19/2015 02:43 PM - Shimon Shtein

Fixes #12461 - Compute profile is properly selected.

Revision d865abb7 - 12/11/2015 12:29 PM - Shimon Shtein

Fixes #12461 - Compute profile is properly selected.

(cherry picked from commit 95d706426644f40b7ed434d26bf237e643a17a1b)

History

#1 - 11/12/2015 05:31 PM - Brandon Weeks

This is actually a little worse than I thought, the compute profile is not applied even if there is a compute profile in the host group.

Steps to reproduce:

1. Create a new host

2. Select a host group with a compute profile attached

3. Select a compute resource to deploy onto (VMware in our case)

Results: A compute profile is selected and greyed out, indicating it has been inherited and applied. However when you navigate to the "Virtual

Machine" tab on the new host screen, it is apparent that the compute profile has not actually been applied.

Expected results: The compute profile field should be applied when it is inherited from the host group.
#2 - 11/13/2015 03:04 AM - Dominic Cleal

- translation missing: en.field_release set to 63

#3 - 11/13/2015 04:15 AM - Dominic Cleal

- Related to Bug #9591: Override puppet configuration on host level does not work if specified on host group added

#4 - 11/13/2015 04:23 AM - Dominic Cleal

Expected results: The compute profile field should not be selected and left active for the user to make a selection

 It appears that #9591 removed the "include_blank" attribute on the compute_profile field, so there's no longer any way to have no compute profile. 

Adding this back appears, on the surface, to fix it.

This is actually a little worse than I thought, the compute profile is not applied even if there is a compute profile in the host group.

 I can't reproduce this aspect on a libvirt compute resource, at least.  The selection of a compute resource should trigger this AJAX request:

Started POST "/hosts/compute_resource_selected"

 If you can enable SQL debugging (http://theforeman.org/manuals/1.10/index.html#7.2Debugging) then you should also see lookups of

compute_attributes, e.g.

ComputeAttribute Load (0.1ms)  SELECT "compute_attributes".* FROM "compute_attributes" WHERE "compute_attribut

es"."compute_resource_id" = 1 AND "compute_attributes"."compute_profile_id" = 4 LIMIT 1

#5 - 11/15/2015 04:00 AM - Shimon Shtein

- Assignee set to Shimon Shtein

#6 - 11/15/2015 09:23 AM - Shimon Shtein

There is a workaround for the issue for the meantime:

Select the hostgroup first, then the fields will be set to "inherit", and the system will behave as expected.

#7 - 11/16/2015 04:16 AM - Dominic Cleal

- Priority changed from Urgent to Normal

Brandon Weeks wrote:

Results: A compute profile is selected and greyed out, indicating it has been inherited and applied. However when you navigate to the "Virtual

Machine" tab on the new host screen, it is apparent that the compute profile has not actually been applied.

Expected results: The compute profile field should not be selected and left active for the user to make a selection

 Yes, this does seem to just be in the UI - it doesn't apply the profile.

Shimon Shtein wrote:

There is a workaround for the issue for the meantime:

Select the hostgroup first, then the fields will be set to "inherit", and the system will behave as expected.

 I think this describes a slightly different issue, but perhaps from the same thing.  If you select the compute resource first, then a host group without a

profile, then it applies settings from the first profile in the list.

#8 - 11/16/2015 10:42 AM - The Foreman Bot

- Status changed from New to Ready For Testing

- Pull request https://github.com/theforeman/foreman/pull/2914 added

#9 - 11/19/2015 08:28 AM - Shimon Shtein

Problems that I have found in code:
1. AJAX requests are passing empty values for inherited fields (environment, compute_profile, puppet_proxy e.t.c), which interferes with the normal

flow of hostgroup selection.

2. Hostgroup selection changes only the compute_profile, but does not affect the actual values of the "Virtual machine" tab.

Test cases:

1. With locations organizations enabled:   * go to /hosts/new   * Select organization (AJAX will be fired)   * Select a hostgroup

Expected: Environment field disabled with a value from the hostgroup shown

Actual: Environment field enabled, the value remains empty.

Didn't check it actually, but selection of compute resource in step 2 should lead to the same result.

2.   * Create a hostgroup with a compute profile that is not the first one (if you have 1-Small, 2-Medium, 3-Large use large or medium)   * Go to

/hosts/new   * Select a compute resource   * Ensure that properties in "Virtual machine" tab are from the first compute profile   * Select the hostgroup

from the first step   * Go to "Virtual machine" tab

Expected: properties are set according to large/medium profile.

Actual: properties are set according to small (first) profile.

#10 - 11/19/2015 03:01 PM - Shimon Shtein

- Status changed from Ready For Testing to Closed

- % Done changed from 0 to 100

Applied in changeset 95d706426644f40b7ed434d26bf237e643a17a1b.

#11 - 11/26/2015 10:22 AM - Dominic Cleal

- Related to Bug #12618: Compute profile overrides compute attributes provided in host form added

#12 - 12/02/2015 04:33 AM - Dominic Cleal

- Related to Bug #12659: Value cannot be overridden by unpressing the "inherit" button added

#13 - 12/13/2015 08:48 AM - Tomer Brisker

- Related to Bug #12793: organzation and location not saved for hostgroup added

#14 - 12/13/2015 09:28 AM - Ori Rabin

- Related to Bug #12794: Environment in host isn't saved added

#15 - 01/05/2016 09:56 AM - Dominic Cleal

- Related to Bug #13004: Compute Profiles not Inheriting from nested host group added
